/*
Copyright 2010-2012 Sergey Levin


This file is part of crosti.

Crosti is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Crosti is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with crosti.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef COLORS_H
#define COLORS_H


#include <QColor>


class _colorCount
{
public:
 QRgb _color;
 int _count;
 bool operator < (const _colorCount &cc) const {return _count < cc._count;}
};


class ColorPalette
{
  //см. http://faqs.org.ru/progr/graph/graph.htm раздел: 3. 'Близость' ('схожесть') цветов.

  //----------------------------------------------------------------------------

public:

    struct Color
    {
        QRgb    _value;
        QString _number;
        QString _description;
    };

  QList<Color>color;//Цвета палитры

  ColorPalette();
  ~ColorPalette(){color.clear();}
  QRgb find(const QColor& cl, int pos = 0) const;
  void open(const QString &name);
  static QRgb blank(){return 0x00000000;}//Прозрачный чёрный
  static float distance(QRgb c1,QRgb c2);
  static QString name();    
};

#endif // COLORS_H
